%define aname apache2
%define apache_version 2.2.9

%define mmn 20051115

Name: apache2-experimental
Version: %apache_version
Release: alt4
License: Apache Software License
Group: System/Servers
Url: http://httpd.apache.org/
Packager: Boris Savelev <boris@altlinux.org>

Summary: Experimental Multi-Processing Module for the Apache 2

# SVN URL: http://svn.apache.org/repos/asf/httpd/httpd/tags/2.2.4
Source: httpd-%version.tar
Source5: README-itk.html
Source6: README-peruser.html
Source13: apache2-alt-alternatives-0.2.tar

Patch1: apache2-%version-alt-debian.conf-0.2.patch
Patch2: apache2-%version-alt-default_https.conf.in-0.1.patch
Patch3: apache2-%version-alt-configs-0.1.patch
Patch4: apache2-%version-alt-cgi-0.1.patch
Patch11: http://www.telana.com/files/httpd-2.2.3-peruser-0.3.0.patch
Patch21: http://mpm-itk.sesse.net/apache2.2-mpm-itk-2.2.6-02/01-copy-prefork.patch
Patch22: http://mpm-itk.sesse.net/apache2.2-mpm-itk-2.2.6-02/02-rename-prefork-to-itk.patch
Patch23: alt-03-add-mpm-to-build-system.patch
Patch24: http://mpm-itk.sesse.net/apache2.2-mpm-itk-2.2.6-02/04-correct-output-makefile-location.patch
Patch25: http://mpm-itk.sesse.net/apache2.2-mpm-itk-2.2.6-02/05-add-copyright.patch
Patch26: http://mpm-itk.sesse.net/apache2.2-mpm-itk-2.2.6-02/06-base-functionality.patch
Patch27: http://mpm-itk.sesse.net/apache2.2-mpm-itk-2.2.6-02/07-max-clients-per-vhost.patch
Patch28: http://mpm-itk.sesse.net/apache2.2-mpm-itk-2.2.6-02/08-capabilities.patch
Patch29: http://mpm-itk.sesse.net/apache2.2-mpm-itk-2.2.6-02/09-nice.patch

BuildRequires(pre): rpm-macros-apache2 >= 1.1
BuildRequires(pre): libssl-devel
BuildPreReq: webserver-common
BuildPreReq: libapr1-devel >= 1.2.8
BuildPreReq: libaprutil1-devel >= 1.2.8
# Fix autoconf version
BuildPreReq: autoconf_2.50
# Automatically added by buildreq on Fri Mar 31 2006
BuildRequires: zlib-devel
BuildPreReq: alternatives
BuildPreReq: pkg-config
BuildPreReq: libgdbm-devel
BuildPreReq: libexpat-devel
BuildPreReq: libpcre-devel
BuildPreReq: libldap-devel
BuildPreReq: libsasl2-devel libsasl2-plugin-gssapi
BuildPreReq: libssl
#following is required by dbmmanage
BuildPreReq: perl-DBM perl-Digest-SHA1 zlib-devel

%description
Experimental MPM for Apache 2

%package -n %aname-httpd-itk
Summary: Experimental Multi-Processing Module for the Apache 2 (itk-mpm)
Group: System/Servers
PreReq: %aname-common
Requires: %aname-mmn = %mmn
Requires: %aname-%apache2_libssl_name = %apache2_libssl_soname
Provides: %apache2_sbindir/%apache2_dname
Provides: %aname-httpd = %version-%release
Provides: %aname-httpd-prefork-like

%description -n %aname-httpd-itk
The ITK Multi-Processing Module (MPM) works in about the same way as the classical "prefork" module
(that is, without threads), except that it allows you to constrain each individual vhost to a particular
system user. This allows you to run several different web sites on a single server without worrying that
they will be able to read each others' files.

%package -n %aname-httpd-peruser
Summary: Experimental Multi-Processing Module for the Apache 2 (peruser-mpm)
Group: System/Servers
PreReq: %aname-common
Requires: %aname-mmn = %mmn
Requires: %aname-%apache2_libssl_name = %apache2_libssl_soname
Provides: %apache2_sbindir/%apache2_dname
Provides: %aname-httpd = %version-%release
Provides: %aname-httpd-prefork-like

%description -n %aname-httpd-peruser
Peruser is an Apache 2 module based on metuxmpm, a working implementation of the perchild MPM.
The fundamental concept behind all of them is to run each apache child process as its own user and group,
each handling its own set of virtual hosts. Peruser and recent metuxmpm releases can also chroot() apache processes.
The result is a sane and secure web server environment for your users, without kludges like PHP's safe_mode.

%prep
# Fix autoconf version
%set_autoconf_version 2.5

# We dont need to expand builddir yet

%setup -q -n httpd-%version
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

#peruser patches
%patch11 -p1

# itk patches
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1

# generate ALTLinux Apache layout
echo "
# ALTLinux layout
<Layout ALTLinux>
    prefix:		%apache2_basedir
    exec_prefix:	%apache2_exec_prefix
    bindir:		%apache2_bindir
    sbindir:		%apache2_sbindir
    libdir:		%apache2_libdir
    libexecdir:		%apache2_moduledir
    mandir:		%apache2_mandir
    sysconfdir:		%apache2_confdir
    datadir:		%apache2_datadir
    iconsdir:		%apache2_iconsdir
    htdocsdir:		%apache2_htdocsdir
    manualdir:		%apache2_manualdir
    cgidir:		%apache2_cgibindir
    includedir:		%apache2_includedir
    localstatedir:	%apache2_localstatedir
    runtimedir:		%apache2_runtimedir
    logfiledir:		%apache2_logfiledir
    proxycachedir:	%apache2_proxycachedir
    infodir:		%apache2_infodir
    installbuilddir:	%apache2_installbuilddir
    errordir:		%apache2_errordir
</Layout>
" >> config.layout

# Safety check: prevent build if defined MMN does not equal upstream MMN.
vmmn=`echo MODULE_MAGIC_NUMBER_MAJOR | cpp -include $PWD/include/ap_mmn.h | grep -e '^[0-9]'`
if [ "$vmmn" != "%mmn" ]; then
   : Error: Upstream MMN is now ${vmmn}, packaged MMN is %mmn.
   : Update the mmn macro and rebuild.
   exit 1
fi

%build
function mpmbuild()
{
mpm=$1; shift
mkdir $mpm; pushd $mpm
cat > config.cache <<EOF
ac_cv_func_pthread_mutexattr_setpshared=no
ac_cv_func_sem_open=no
EOF
../configure -C \
	--enable-layout=ALTLinux \
	--with-pcre=%_usr/bin/pcre-config \
	--with-perl=perl \
	--with-apr=%apache2_apr_config \
	--with-apr-util=%apache2_apu_config \
	--enable-suexec --with-suexec \
	--with-suexec-caller=%apache2_user \
	--with-suexec-docroot=%apache2_suexec_docroot \
	--with-suexec-logfile=%apache2_logfiledir/suexec.log \
	--with-suexec-bin=%apache2_sbindir/suexec%apache2_branch \
	--with-suexec-uidmin=500 --with-suexec-gidmin=500 \
	--with-suexec-userdir=public_html \
	--enable-so \
	--with-mpm=$mpm \
        --with-devrandom \
        --with-ldap --enable-ldap --enable-auth-ldap --enable-authnz-ldap \
        --enable-cache --enable-disk-cache --enable-mem-cache \
	--enable-ssl --with-ssl \
	--enable-deflate --enable-cgid \
	--enable-proxy --enable-proxy-connect \
	--enable-proxy-http --enable-proxy-ftp \
	--enable-charset_lite=shared \
	$*

%make_build
popd
}

ln -snf %_datadir/apr-1/build/PrintPath build/PrintPath
libtoolize --ltdl
autoheader
autoconf -I %_datadir/apr-1

# original build for verify module
mpmbuild prefork --enable-mods-shared=all --with-program-name=%apache2_dname

mpmbuild itk --enable-mods-shared=all --with-program-name=%apache2_dname

mpmbuild peruser --enable-mods-shared=all --with-program-name=%apache2_dname

# Verify that the same modules were built into the two httpd binaries
./prefork/%apache2_dname -l | grep -v prefork > prefork.mods
./itk/%apache2_dname -l | grep -v itk > itk.mods
./peruser/%apache2_dname -l | grep -v peruser > peruser.mods
if ( ! diff -u prefork.mods itk.mods ) || ( ! diff -u prefork.mods peruser.mods ) ; then
  : Different modules built into httpd binaries, will not proceed
  exit 1
fi

%install
mkdir -p %buildroot%apache2_sbindir
WDIR=itk
install -m 755 $WDIR/%apache2_dname %buildroot%apache2_sbindir/%apache2_dname.itk
WDIR=peruser
install -m 755 $WDIR/%apache2_dname %buildroot%apache2_sbindir/%apache2_dname.peruser

mkdir -p %buildroot%_altdir
pushd %buildroot%_altdir
tar xvSf %SOURCE13
popd
install -m 644 {%SOURCE5,%SOURCE6} %_builddir/httpd-%version

%triggerin -- %aname-httpd-itk
if [ $1 -eq 2 ] || [ $1 -eq 1 ]; then
	%post_service %apache2_dname
fi
exit 0

%triggerun -- %aname-httpd-itk
if [ $1 -eq 0 ]; then
	%preun_service %apache2_dname
fi
exit 0

%post -n %aname-httpd-itk
%register_alternatives %aname-httpd-itk

%triggerpostun -n %aname-httpd-itk -- apache2 < 2.2.4-alt18
%register_alternatives %aname-httpd-itk

%postun -n %aname-httpd-itk
%unregister_alternatives %aname-httpd-itk

%triggerin -- %aname-httpd-peruser
if [ $1 -eq 2 ] || [ $1 -eq 1 ]; then
	%post_service %apache2_dname
fi
exit 0

%triggerun -- %aname-httpd-peruser
if [ $1 -eq 0 ]; then
	%preun_service %apache2_dname
fi
exit 0

%post -n %aname-httpd-peruser
%register_alternatives %aname-httpd-peruser

%triggerpostun -n %aname-httpd-peruser -- apache2 < 2.2.4-alt18
%register_alternatives %aname-httpd-peruser

%postun -n %aname-httpd-peruser
%unregister_alternatives %aname-httpd-peruser

%files -n %aname-httpd-itk
%doc README-itk.html
%apache2_sbindir/%apache2_dname.itk
%_altdir/%aname-httpd-itk

%files -n %aname-httpd-peruser
%doc README-peruser.html
%apache2_sbindir/%apache2_dname.peruser
%_altdir/%aname-httpd-peruser

%changelog
* Sat Nov 15 2008 Boris Savelev <boris@altlinux.org> 2.2.9-alt4
- fix provides

* Thu Nov 13 2008 Boris Savelev <boris@altlinux.org> 2.2.9-alt3
- Remove libdb application switch using and %%name-%%apache2_libdb_name provides
- Add provides %%name-httpd-prefork-like for %%name-httpd-prefork

* Mon Nov 10 2008 Boris Savelev <boris@altlinux.org> 2.2.9-alt2
- rebuild with new aprutils1 (remove BuildReq: libdb-devel)

* Fri Sep 12 2008 Boris Savelev <boris@altlinux.org> 2.2.9-alt1
- initial build for Sisyphus

